// ////////////////////////////////////////////////////
//
// StdView.cpp : implementation of the CStdView class
// Based on class COGLView : public CView
// Inspect COGLView for standard OpenGL initialization
//
////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Std.h"

#include "StdDoc.h"
#include "StdView.h"

#include "math.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////
// You can put definitions, variables and helperfunctions
// here. Functions that does not rely on CStdView member
// variables or functions
// definitions according to assignment
#define TakL	7.0f
#define VeggL	6.0f
#define TakB	3.0f
#define VeggB	4.0f
#define VeggH	2.40f
#define HusH	4.0f
#define VS		1.0f

///////////////////////////////////////////
// routines for house

// all drawing counterclockwise as seen from outside
// house, and normals pointing out of house

void TegnGulv()
{
	glBegin(GL_POLYGON);
	glNormal3f(0.0f,0.0f,-1.0f);
	glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,VeggL,0.0f);
	glVertex3f(VeggB,VeggL,0.0f);
	glVertex3f(VeggB,0.0f,0.0f);
	glEnd();
}

void TegnTak()
{
	// top angle of roof is described as:
	// tg(v)=(VeggB/2) / (HusH-VeggH)
	GLfloat v=(GLfloat)atan2((VeggB/2.0f),(HusH-VeggH));
	// height of roof-edge
	GLfloat RoofEdge=HusH-TakB*(GLfloat)cos(v);

	//westwds
	glBegin(GL_POLYGON);
	glNormal3f(0.0f,0.0f,1.0f);// unpresice
	glVertex3f(VeggB/2.0f,
				-(TakL-VeggL)/2.0f,
				HusH);
	glVertex3f(VeggB/2.0f,
				VeggL+(TakL-VeggL)/2,
				HusH);
	glVertex3f(VeggB/2.0f-TakB*(GLfloat)sin(v),
				VeggL+(TakL-VeggL)/2,
				RoofEdge);
	glVertex3f(VeggB/2.0f-TakB*(GLfloat)sin(v),
				-(TakL-VeggL)/2.0f,
				RoofEdge);
	glEnd();

	//eastwds
	glBegin(GL_POLYGON);
	glNormal3f(0.0f,0.0f,1.0f);// unpresice
	glVertex3f(VeggB/2.0f,
				-(TakL-VeggL)/2.0f,
				HusH);
	glVertex3f(VeggB/2.0f+TakB*(GLfloat)sin(v),
				-(TakL-VeggL)/2.0f,
				RoofEdge);
	glVertex3f(VeggB/2.0f+TakB*(GLfloat)sin(v),
				VeggL+(TakL-VeggL)/2,
				RoofEdge);
	glVertex3f(VeggB/2.0f,
				VeggL+(TakL-VeggL)/2,
				HusH);
	glEnd();

}

void TegnVestVegg()
{
	/*
	glBegin(GL_POLYGON);
	glNormal3f(-1.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,VeggH);
	glVertex3f(0.0f,VeggL,VeggH);
	glVertex3f(0.0f,VeggL,0.0f);
	glEnd();
	*/
	// make hole for window
	// by drawing the four surrounding
	// rectangles

	// window sills:
	GLfloat south=(VeggL-VS)/2.0f;
	GLfloat north=south+VS;
	GLfloat under=(VeggH-VS)/2.0f;
	GLfloat over=under+VS;
	// under
	glBegin(GL_POLYGON);
	glNormal3f(-1.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,under);
	glVertex3f(0.0f,VeggL,under);
	glVertex3f(0.0f,VeggL,0.0f);
	glEnd();
	// over
	glBegin(GL_POLYGON);
	glNormal3f(-1.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,over);
	glVertex3f(0.0f,0.0f,VeggH);
	glVertex3f(0.0f,VeggL,VeggH);
	glVertex3f(0.0f,VeggL,over);
	glEnd();
	// south
	glBegin(GL_POLYGON);
	glNormal3f(-1.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,VeggH);
	glVertex3f(0.0f,south,VeggH);
	glVertex3f(0.0f,south,0.0f);
	glEnd();
	//north
	glBegin(GL_POLYGON);
	glNormal3f(-1.0f,0.0f,0.0f);
	glVertex3f(0.0f,north,0.0f);
	glVertex3f(0.0f,north,VeggH);
	glVertex3f(0.0f,VeggL,VeggH);
	glVertex3f(0.0f,VeggL,0.0f);
	glEnd();
}

void TegnNordVegg()
{
	glBegin(GL_POLYGON);
	glNormal3f(0.0f,1.0f,0.0f);
	glVertex3f(0.0f,VeggL,0.0f);
	glVertex3f(0.0f,VeggL,VeggH);
	glVertex3f(VeggB/2.0f,VeggL,HusH);
	glVertex3f(VeggB,VeggL,VeggH);
	glVertex3f(VeggB,VeggL,0.0f);
	glEnd();
}

void TegnSorVegg()
{
	glBegin(GL_POLYGON);
	glNormal3f(0.0f,-1.0f,0.0f);
	glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(VeggB,0.0f,0.0f);
	glVertex3f(VeggB,0.0f,VeggH);
	glVertex3f(VeggB/2.0f,0.0f,HusH);
	glVertex3f(0.0f,0.0f,VeggH);
	glEnd();
}

void TegnOstVegg()
{
	glBegin(GL_POLYGON);
	glNormal3f(1.0f,0.0f,0.0f);
	glVertex3f(VeggB,0.0f,0.0f);
	glVertex3f(VeggB,VeggL,0.0f);
	glVertex3f(VeggB,VeggL,VeggH);
	glVertex3f(VeggB,0.0f,VeggH);
	glEnd();
}

void TegnKrakk()
{
	GLUquadricObj *glpQ;
	glpQ = gluNewQuadric();

	// krakk is as high as it is wide
	// draw it in a unit box standing on the xy-plane 
	// with center i origo
	
	// top first
	glPushMatrix();
	glTranslatef(0.0f,0.0f,0.9f);
	gluDisk(glpQ,0.0f,0.5f,10,10);
	gluCylinder(glpQ,0.5f,0.5f,0.1f,10,10);
	glTranslatef(0.0f,0.0f,0.1f);
	gluDisk(glpQ,0.0f,0.5f,10,10);
	glPopMatrix();
	//legs
	glPushMatrix();
	glTranslatef(0.3f,0.0f,0.0f);
	gluCylinder(glpQ,0.05f,0.05f,0.95f,10,10);
	glPopMatrix();
	//
	glPushMatrix();
	glRotatef(120.0f,0.0f,0.0f,1.0f);
	glTranslatef(0.3f,0.0f,0.0f);
	gluCylinder(glpQ,0.05f,0.05f,0.95f,10,10);
	glPopMatrix();
	//
	glPushMatrix();
	glRotatef(240.0f,0.0f,0.0f,1.0f);
	glTranslatef(0.3f,0.0f,0.0f);
	gluCylinder(glpQ,0.05f,0.05f,0.95f,10,10);
	glPopMatrix();

	gluDeleteQuadric(glpQ);
}

void TegnMobler(int n)
{
	// draw it standing in the xy-plane
	// with center in origo
	// preserve matrix
	glPushMatrix();
	
	// move origo to center of house
	glTranslatef(VeggB/2.0f,VeggL/2.0f,0.0f);

	// must make some decisions about dimensions:
	// a chair is 0.7 the size of a table, reasonable
	GLfloat ChairScale=0.7f;
	// the min dimension of the floor should take four
	// tables in a row, reasonable
	GLfloat TableSize=min(VeggB,VeggL)/4.0f;
	
	// do the table
	glScalef(TableSize,TableSize,TableSize);
	TegnKrakk();

	// then we do the chairs
	n=min(max(n,0),5);
	for(int ix=0;ix<=n;ix++)
	{
		glPushMatrix();
			glRotatef(ix*360.0f/n,0.0f,0.0f,1.0f);
			glTranslatef(TableSize,0.0f,0.0f);
			glScalef(ChairScale,ChairScale,ChairScale);
			TegnKrakk();
		glPopMatrix();
	}

	// reset matrix as on entry
	glPopMatrix();
}

//////////////////////////////////////////////////////////
// CStdView

IMPLEMENT_DYNCREATE(CStdView, COGLView)

BEGIN_MESSAGE_MAP(CStdView, COGLView)
	//{{AFX_MSG_MAP(CStdView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_INSPECTION_THROUGHWALLS, OnInspectionThroughwalls)
	ON_UPDATE_COMMAND_UI(ID_INSPECTION_THROUGHWALLS, OnUpdateInspectionThroughwalls)
	ON_COMMAND(ID_FURNITURE_ADDCHAIR, OnFurnitureAddchair)
	ON_COMMAND(ID_FURNITURE_REMOVECHAIR, OnFurnitureRemovechair)
	ON_UPDATE_COMMAND_UI(ID_FURNITURE_ADDCHAIR, OnUpdateFurnitureAddchair)
	ON_UPDATE_COMMAND_UI(ID_FURNITURE_REMOVECHAIR, OnUpdateFurnitureRemovechair)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////
// CStdView construction/destruction

CStdView::CStdView()
{
	// initialize angles, see DrawScene
	m_xv=0.0f;
	m_yv=0.0f;

	m_BInspection=FALSE;
	m_nChairs=3;

	m_hRC=NULL;
	m_hDC=NULL;
};

CStdView::~CStdView()
{}

////////////////////////////////////////////////////////////
// CStdView diagnostics
// You should usually not touch these:
#ifdef _DEBUG
void CStdView::AssertValid() const
{COGLView::AssertValid();}
void CStdView::Dump(CDumpContext& dc) const
{COGLView::Dump(dc);}

CStdDoc* CStdView::GetDocument() // non-debug version is inline
{	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStdDoc)));
	return (CStdDoc*)m_pDocument;
}
#endif //_DEBUG

//////////////////////////////////////////////////////////////
// CStdView operations

void CStdView::DrawScene()
{
	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
	// Set up for scene
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	// put origo in houses soth-west corner
	gluLookAt(	2*VeggB,-2*VeggL,2*HusH,
				0.0f,0.0f,0.0f,
				0.0f,0.0f,1.0f);

	////////////////////////////////////
	// pick up user manipulation
	// rotate around x-axis 
	glRotatef(m_xv,1.0f,0.0f,0.0f);
	// rotate around z-axis 
	glRotatef(m_yv,0.0f,0.0f,1.0f);
	/////////////////////////////////////

	// lighten up both back and front side og polygon
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);

	//////////////////////////////////////
	// draw furniture
	glDisable(GL_CULL_FACE); // never cull furniture
	CMaterial::SetMaterial(YELLOW_PLASTIC);
	TegnMobler(m_nChairs);

	// do we want to inspect inside:
	if(m_BInspection)
	{
		glCullFace(GL_FRONT);
		glEnable(GL_CULL_FACE);
	}

	/////////////////////////////
	// Draw the house
	CMaterial::SetMaterial(YELLOW_PLASTIC);
	TegnGulv();
	CMaterial::SetMaterial(BLACK_PLASTIC);
	TegnTak();
	CMaterial::SetMaterial(RED_PLASTIC);
	TegnVestVegg();
	TegnNordVegg();
	TegnSorVegg();
	TegnOstVegg();
	
	// finnish drawing
	glFlush();
}

void CStdView::InitializeRContext()
{
	// Here we set the attributes that will be constant
	// during the rendering contexts lifetime
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    
	// prepare ligthsource
	GLfloat ambient[] = {0.2f,0.2f,0.2f,1.0f };
    GLfloat diffuse[] = {1.0f,1.0f,1.0f,1.0f };
    GLfloat position[] = {4.0f,0.0f,6.0f,0.0f };
	GLfloat lmodel_ambient[] = {0.4f,0.4f,0.4f,1.0f };


    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_POSITION, position);
	
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);

	// smooth the drawing
	glShadeModel(GL_SMOOTH);

    // set background to light gray
	glClearColor(0.8f, 0.8f, 0.8f, 0.0f);
}

void CStdView::SetPerspective(int cx, int cy)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluPerspective(50.0f, (GLdouble)cx/cy, 0.1f, 70.0f);
	glMatrixMode(GL_MODELVIEW);
}


void CStdView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// User has pressed left button.Make a note
	// of this and prepare for intuitive rotation of scene
	m_PLast=point;
	SetCapture();
	CView::OnLButtonDown(nFlags, point);
}

void CStdView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// free capture and terminate rotation
	ReleaseCapture();
	CView::OnLButtonUp(nFlags, point);
}

void CStdView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// if left button is down 
	if(nFlags && MK_LBUTTON)
	{	
		// and has moved a significant dist
		if((abs(m_PLast.x-point.x)>2)||(abs(m_PLast.y-point.y)>2))
		{
			// then we find an intuitive rot angle
			CRect R;
			GetClientRect(&R);
			
			m_yv+=90.0f*((GLfloat (point.x-m_PLast.x))/GLfloat (R.Width()));
			m_xv+=90.0f*((GLfloat (point.y-m_PLast.y))/GLfloat (R.Height()));
			
			// rememeber point and force immediate redraw 
			m_PLast=point;
			RedrawWindow();
		}
	}
}

void CStdView::OnInspectionThroughwalls() 
{
	m_BInspection=!m_BInspection;
	RedrawWindow();
}

void CStdView::OnUpdateInspectionThroughwalls(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_BInspection);
}

void CStdView::OnFurnitureAddchair() 
{
	m_nChairs++;
	RedrawWindow();
}

void CStdView::OnFurnitureRemovechair() 
{
	m_nChairs--;
	RedrawWindow();
}

void CStdView::OnUpdateFurnitureAddchair(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_nChairs<5);
}

void CStdView::OnUpdateFurnitureRemovechair(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_nChairs>0);
}
